;
; Virtual Keyboard for ppmck
;
;                   Ver.0.01b
;

	.include	"define.inc"

__VRC6	=	%00000001
__VRC7	=	%00000010
__FDS	=	%00000100
__MMC5	=	%00001000
__N106	=	%00010000
__FME7	=	%00100000

; INES header setup -----------------------------
	.if	SOUND_GENERATOR & __VRC7
	.inesprg	(BANK_MAX_IN_4KB/4)+1	; One 16k prg bank
	.ineschr	0			; One 8k  chr bank
	.inesmir	0			; Vertical map mirroring
	.inesmap	85			; VRC7
	.endif
	.if	SOUND_GENERATOR & __VRC6
	.inesprg	(BANK_MAX_IN_4KB/4)+1	; One 16k prg bank
	.ineschr	1			; One 8k  chr bank
	.inesmir	0			; Vertical map mirroring
	.inesmap	24			; VRC6
	.endif
	.if	SOUND_GENERATOR & __N106
	.inesprg	(BANK_MAX_IN_4KB/4)+1	; One 16k prg bank
	.ineschr	1			; One 8k  chr bank
	.inesmir	0			; Vertical map mirroring
	.inesmap	19			; N106
	.endif
	.if	SOUND_GENERATOR & __MMC5
	.inesprg	(BANK_MAX_IN_4KB/4)+1	; One 16k prg bank
	.ineschr	1			; One 8k  chr bank
	.inesmir	0			; Vertical map mirroring
	.inesmap	5			; MMC5
	.endif
	.if	SOUND_GENERATOR & __FME7
	.inesprg	(BANK_MAX_IN_4KB/4)+1	; One 16k prg bank
	.ineschr	1			; One 8k  chr bank
	.inesmir	0			; Vertical map mirroring
	.inesmap	69			; SS5B
	.endif
;------------------------------------------------

	.bank	0
	.org	$8000
	.code

	TITLE
	COMPOSER
	MAKER

	db	SOUND_GENERATOR

	.include	"ppmck/vk/virtkey.h"	; ꂪ݂

Loop:
	jmp	Loop			;

NMI_Routine:
	jsr	SPR_DMA			; K{
	jsr	sound_driver_start
	jsr	VKEY_DISP		; K{
IRQ_Routine:				;Dummy label
	rti
;-------------------------------------------------------------------------------
	.include	"ppmck/sounddrv_vk.h"
	.include	"ppmck/internal.h"
	.include	"ppmck/dpcm_vk.h"

	.if	SOUND_GENERATOR & __FDS
	.include	"ppmck/fds.h"
	.endif
	.if	SOUND_GENERATOR & __VRC7
	.include	"ppmck/vrc7.h"
	.endif
	.if	SOUND_GENERATOR & __VRC6
	.include	"ppmck/vrc6.h"
	.endif
	.if	SOUND_GENERATOR & __N106
	.include	"ppmck/n106.h"
	.endif
	.if	SOUND_GENERATOR & __MMC5
	.include	"ppmck/mmc5.h"
	.endif
	.if	SOUND_GENERATOR & __FME7
	.include	"ppmck/fme7.h"
	.endif

	.include	"ppmck/freqdata.h"
	.include	"effect.h"


	.bank	(BANK_MAX_IN_4KB/2)+(BANK_MAX_IN_4KB/2+1)%2
	.org	$FF00
Reset_Routine:
	cld
	sei
	ldx	#$00
	stx	$2000
	stx	$2001
.WaitV:	
	lda	$2002
	bpl	.WaitV

	;VRC7
	.if	SOUND_GENERATOR & __VRC7
	ldx	#$00
	stx	$8000 ; 8000h-9FFFh
	inx
	stx	$8010 ; A000h-BFFFh
	inx
	stx	$9000 ; C000h-DFFFh

	;łCHR-RAM BANK
	ldx	#$00
	stx	$A000
	inx
	stx	$A010
	inx
	stx	$B000
	inx
	stx	$B010
	inx
	stx	$C000
	inx
	stx	$C010
	inx
	stx	$D000
	inx
	stx	$D010
	.endif

	;VRC6
	.if	SOUND_GENERATOR & __VRC6
	ldx	#$00
	stx	$8000 ; 8000h-BFFFh
	inx
	inx
	stx	$C000 ; C000h-DFFFh
	ldx	#$00
	stx	$D000
	inx
	stx	$D001
	inx
	stx	$D002
	inx
	stx	$D003
	.endif
	;N106
	.if	SOUND_GENERATOR & __N106
	ldx	#$00
	stx	$E000 ; 8000h-9FFFh
	inx
	stx	$E800 ; A000h-BFFFh
	inx
	stx	$F000 ; C000h-DFFFh
	ldx	#$00
	stx	$8000
	inx
	stx	$8800
	inx
	stx	$9000
	inx
	stx	$9800
	lda	#$E0
	sta	$C000
	sta	$C800
	sta	$D000
	sta	$D800
	.endif
	;MMC5
	.if	SOUND_GENERATOR & __MMC5
	lda #$00
	sta $5100
	sta $5200

	lda #$01
	sta $5101

	lda #$02
	sta $5104

	lda #$80
	sta $5115
	sta $5117

	lda #$02	;WRITE PROTECT
	sta $5102
	lda #$01
	sta $5103
	lda #$00
	sta $5113

	lda #$50	;MIRROR
	sta $5105

	lda #$00
	sta $512b
	sta $5123
	lda #$01
	sta $5127
	.endif
	.if	SOUND_GENERATOR & __FME7
	.endif

	jsr	sound_init

	jsr	VKEY_SETUP
	lda	#%00011000	; BG/SP on
	sta	$2001
	lda	#%10100000	; NMI/x16sprite
	sta	$2000
	cli
	jmp	Loop

; Vector
	.bank	(BANK_MAX_IN_4KB/2)+(BANK_MAX_IN_4KB/2+1)%2
	.org	$FFFA
	.dw	NMI_Routine
	.dw	Reset_Routine
	.dw	IRQ_Routine

	.if	SOUND_GENERATOR & __VRC7
	.else
	.bank	(BANK_MAX_IN_4KB/2)+(BANK_MAX_IN_4KB/2+1)%2+1
	.incbin "ppmck/vk/vkchr2.bin"
	.endif
